// IDAClient.aidl
package com.lbe.doubleagent.client;

import android.net.Uri;

import com.lbe.doubleagent.service.DAUser;
import com.lbe.doubleagent.service.DAPackage;
import com.lbe.doubleagent.service.PendingResultInfo;

interface IDAClient {
    // process
    int prepareForceStop();
    oneway void forceStop();

    // activity
    boolean startActivity(in IBinder token, in Intent intent, in Bundle options);
    boolean startActivities(in IBinder token, in Intent[] intents, in Bundle options);
    void stopActivity(in IBinder token);
    void sendNewIntent(in String callerPackage, in IBinder token, in Intent intent);

    // broadcast
    void sendBroadcast(in ComponentName receiverInfo, in PendingResultInfo pendingResultInfo, in Intent broadcast);

    // provider
    IBinder getContentProvider(in ProviderInfo providerInfo);

    // service
    List allRunningServices();
    boolean stopService(in ComponentName componentName, in int startId);
    void addServiceConnection(in IDAClient client, in IBinder connection, in ComponentName service);
    void removeServiceConnection(in IDAClient client, in IBinder connection);

    void setHttpProxy(in String host, in String port, in String exclList, in Uri pacFileUrl);
}
