package com.lbe.doubleagent.service;

import android.accounts.Account;
import android.content.SyncInfo;
import android.database.IContentObserver;
import android.content.ISyncStatusObserver;
import android.content.SyncRequest;
import android.content.PeriodicSync;
import android.os.Bundle;

interface IDAContentService {
    void requestSync(in int vuid, in Account account, in String authority, in Bundle extras);
    void sync(in int vuid, in SyncRequest request);
    void cancelSync(in int vuid, in Account account, in String authority);
    void cancelRequest(in int vuid, in SyncRequest request);
    boolean getSyncAutomatically(in int vuid, in Account account, in String authority);
    void setSyncAutomatically(in int vuid, in Account account, in String authority, in boolean sync);
    List<PeriodicSync> getPeriodicSyncs(in int vuid, in Account account, in String authority);
    void addPeriodicSync(in int vuid, in Account account, in String authority, in Bundle extras, in long pollFrequency);
    void removePeriodicSync(in int vuid, in Account account, in String authority, in Bundle extras);
    int getIsSyncable(in int vuid, in Account account, in String authority);
    void setIsSyncable(in int vuid, in Account account, in String authority, in int syncable);
    List getCurrentSyncs(in int vuid);
    boolean isSyncActive(in int vuid, in Account account, in String authority);
    boolean isSyncPending(in int vuid, in Account account, in String authority);
    void addStatusChangeListener(in int vuid, in int mask, in ISyncStatusObserver callback);
    void removeStatusChangeListener(in int vuid, in ISyncStatusObserver callback);
    String[] getSyncAdapterPackagesForAuthority(in int vuid, in String authority);
    void setMasterSyncAutomatically(in int vuid, in boolean flag);
    boolean getMasterSyncAutomatically(in int vuid);

    //for nougate contentobserver
    void unregisterContentObserver(IContentObserver observer);
    void registerContentObserver(in Uri uri, boolean notifyForDescendants, IContentObserver observer, int userHandle);
    void notifyChange(in Uri uri, IContentObserver observer, boolean observerWantsSelfNotifications, int flags, int userHandle);
}
