package com.lbe.doubleagent.service.account;

import android.accounts.IAccountManagerResponse;
import android.accounts.Account;
import com.lbe.doubleagent.service.account.AccountWrapper;
import android.accounts.AuthenticatorDescription;

interface IDAAccountManager {
    boolean isManagedAccount(in int vuid, in String type);
    String getPassword(in int vuid, in Account account);
    String getUserData(in int vuid, in Account account, String key);
    Account[] getAccounts(in int vuid, in String accountType);
    AccountWrapper[] getAccountsDetail(in int vuid, in String accountType);
    void hasFeatures(in int vuid, in IAccountManagerResponse response, in Account account, in String[] features);
    void getAccountsByFeatures(in int vuid, in IAccountManagerResponse response, String accountType, in String[] features);
    boolean addAccountExplicitly(in int vuid, in Account account, String password, in Bundle extras);
    void removeAccountAsUser(in int vuid, in IAccountManagerResponse response, in Account account, boolean expectActivityLaunch);
    boolean removeAccountExplicitly(in int vuid, in Account account);
    void invalidateAuthToken(in int vuid, String accountType, String authToken);
    String peekAuthToken(in int vuid, in Account account, String authTokenType);
    void setAuthToken(in int vuid, in Account account, String authTokenType, String authToken);
    void setPassword(in int vuid, in Account account, String password);
    void clearPassword(in int vuid, in Account account);
    void setUserData(in int vuid, in Account account, String key, String value);
    void getAuthToken(in int vpid, in int vuid, in IAccountManagerResponse response, in Account account, String authTokenType, boolean notifyOnAuthFailure, boolean expectActivityLaunch, in Bundle options);
    void addAccount(in int vuid, in IAccountManagerResponse response, String accountType, String authTokenType, in String[] requiredFeatures, boolean expectActivityLaunch, in Bundle options);
    void updateCredentials(in int vuid, in IAccountManagerResponse response, in Account account, String authTokenType, boolean expectActivityLaunch, in Bundle options);
    void editProperties(in int vuid, in IAccountManagerResponse response, String accountType, boolean expectActivityLaunch);
    void confirmCredentialsAsUser(in int vuid, in IAccountManagerResponse response, in Account account, in Bundle options, boolean expectActivityLaunch);
    boolean accountAuthenticated(in int vuid, in Account account);
    void getAuthTokenLabel(in int vuid, in IAccountManagerResponse response, String accountType, String authTokenType);
    void renameAccount(in int vuid, in IAccountManagerResponse response, in Account accountToRename, String newName);
    String getPreviousName(in int vuid, in Account account);
    AuthenticatorDescription[] getManagedAuthenticatorTypesAsUser(in int vuid);
    // for Android 8.0
    boolean addAccountExplicitlyWithVisibility(in int vuid, in Account account, String password, in Bundle extras, in Map packageToVisibility);
    boolean setAccountVisibility(in int vuid, in Account a, in String packageName, int newVisibility);
    int getAccountVisibility(in int vuid, in Account a, String packageName);
    Map getAccountsAndVisibilityForPackage(in int vuid, String packageName, String accountType);
    Map getPackagesAndVisibilityForAccount(in int vuid, in Account account);
}
