// DALocationService.aidl
package com.lbe.doubleagent.service.location;

import android.location.ILocationListener;
import android.location.LocationRequest;
import android.location.Geofence;

// Declare any non-default types here with import statements

interface IDALocationService {
    void requestLocationUpdates(in LocationRequest request, in ILocationListener listener,
            in PendingIntent intent, String packageName);

    void removeUpdates(in ILocationListener listener, in PendingIntent intent, String packageName);

    void requestGeofence(in LocationRequest request, in Geofence geofence,
            in PendingIntent intent, String packageName);

    void removeGeofence(in Geofence fence, in PendingIntent intent, String packageName);

    Location getLastLocation(in LocationRequest request, String packageName);

    boolean sendExtraCommand(String provider, String command, inout Bundle extras);

    void locationCallbackFinished(ILocationListener listener);

    void reportLocation(in Location location);

    boolean isProviderSupported(String provider);
}
