// IPackageInstaller.aidl
package com.lbe.doubleagent.service.packageinstaller;
import com.lbe.doubleagent.service.packageinstaller.DASessionParams;
import android.graphics.Bitmap;
import android.content.pm.IPackageInstallerSession;
import com.lbe.doubleagent.service.packageinstaller.DASessionInfo;
import com.lbe.doubleagent.service.DAParceledListSlice;
import android.content.pm.IPackageInstallerCallback;
import android.content.IntentSender;

/**
 * Created by leroy on 16-2-18.
 */
interface IDAPackageInstaller {
    int createSession(in DASessionParams params, in String installerPackageName, in int vuid, in String callerUid);
    void updateSessionAppIcon(in int sessionId, in Bitmap appIcon, in int vuid, in String callerUid);
    void updateSessionAppLabel(in int sessionId, in String appLabel, in int vuid, in String callerUid);
    void abandonSession(in int sessionId, in int vuid, in String callerUid);
    IPackageInstallerSession openSession(in int sessionId, in int vuid, in String callerUid);
    DASessionInfo getSessionInfo(in int sessionId);
    DAParceledListSlice getAllSessions(in int vuid);
    DAParceledListSlice getMySessions(in int vuid, String installerPackageName);
    void registerCallback(in IPackageInstallerCallback callback, in int vuid, in String callerUid);
    void unregisterCallback(in IPackageInstallerCallback callback);
    void uninstall(in String packageName, in IntentSender statusReceiver, in int vuid);
    void setPermissionsResult(in int sessionId, in boolean accepted);
}
