package com.lbe.mdremote.common;

import android.accounts.Account;
//import android.accounts.AccountManagerFuture;
import com.lbe.mdremote.common.AccountWrapper;
//import com.lbe.mdremote.common.IAccountManagerCallback;
import android.accounts.IAccountManagerResponse;
import android.os.Bundle;
interface IDAAccountManager {
  Account[] getAccounts(int vuid, String type);
  Account[] getManagedAccountsAsUser(int vuid, String type);
  //void addAccountAsUser(in int vuid, in String accountType, in String authTokenType, in String[] requiredFeatures, in Bundle addAccountOptions, in Activity activity, in IAccountManagerCallback callback, in Handler handler);
  void onUserAdded(int vuid);
  void clearPassword(in int vuid, in Account account);
  boolean isManagedAccount(int vuid, String type);
  String getUserData( in int vuid, in Account account, in String key);
  void onPluginAutoUpgradeSystemPackage(String packageName, boolean isReplace);
  void hasFeatures(in int vuid, in IAccountManagerResponse response, in Account account,in String[] features);
  void addAccount( in int vuid, in IAccountManagerResponse response, in String accountType, in String authTokenType, in String[] requiredFeatures, in boolean expectActivityLaunch,in Bundle options);
  void onPluginPackageAdded(int vuid, String packageName, boolean isFirstAdded);
  String getPassword(in int vuid,in Account account);
  void setUserData(in int vuid, in Account account,in String key,in String value);
  boolean removeAccountExplicitly(in int vuid, in Account account);
  String getPreviousName(in int vuid, in Account account);
  AccountWrapper[] getAccountsDetail(int vuid, String type);
  void getAuthTokenLabel(in int vuid, in IAccountManagerResponse response, in String accountType,in String authTokenType);
  void updateCredentials(in int vuid, in IAccountManagerResponse response, in Account account,in String authTokenType,in boolean expectActivityLaunch,in Bundle loginOptions);
  String peekAuthToken(in int vuid, in Account account, in String authTokenType);
  void confirmCredentialsAsUser(in int vuid, in IAccountManagerResponse response, in Account account, in Bundle options,in boolean expectActivityLaunch);
  void getAuthToken(in int vpid, in int vuid, in IAccountManagerResponse response, in Account account, in String authTokenType, in boolean notifyOnAuthFailure, in boolean expectActivityLaunch,in Bundle loginOptions);
  void removeAccountAsUser(in int vuid, in IAccountManagerResponse response, in Account account, in boolean expectActivityLaunch);
  void getAccountsByFeatures(in int vuid,in IAccountManagerResponse response, in String type, in String[] features);
  void invalidateAuthToken(int vuid, String accountType, String authToken);
  void setAuthToken(in int vuid, in Account account, in String authTokenType, in String authToken);
  void checkInGooglePlay(int vuid);
  void editProperties(in int vuid,in IAccountManagerResponse response, in String accountType,in boolean expectActivityLaunch);
  //AuthenticatorDescription[] getManagedAuthenticatorTypesAsUser(int vuid);
  void renameAccount(in int vuid, in IAccountManagerResponse response, in Account accountToRename, in String newName);
  void setPassword(in int vuid,in Account account, in String password);
  boolean addAccountExplicitly(in int vuid, in Account account,in String password,in Bundle extras);
  boolean accountAuthenticated(in int vuid, in Account account);
  // for Android 8.0
  boolean addAccountExplicitlyWithVisibility(in int vuid, in Account account, String password, in Bundle extras, in Map packageToVisibility);
  boolean setAccountVisibility(in int vuid, in Account a, in String packageName, int newVisibility);
  int getAccountVisibility(in int vuid, in Account a, String packageName);
  Map getAccountsAndVisibilityForPackage(in int vuid, String packageName, String accountType);
  Map getPackagesAndVisibilityForAccount(in int vuid, in Account account);
}
