// IDAPackageManager.aidl
// Notice: any change related to this file,plz be kindly informed.
package com.lbe.mdremote.common;
import com.lbe.mdremote.common.DAUser;
import android.content.pm.ResolveInfo;
import android.content.pm.PackageStats;
import com.lbe.mdremote.common.IDAPackageObserver;
import android.net.Uri;
import android.content.pm.PackageInfo;
import com.lbe.mdremote.common.DACapabilities;
import android.content.pm.ProviderInfo;
import com.lbe.mdremote.common.DAUser;
import com.lbe.mdremote.common.DAPackage;
import android.content.pm.PermissionGroupInfo;
import android.content.pm.PermissionInfo;
import com.lbe.mdremote.common.IDAUserObserver;
import android.content.pm.ApplicationInfo;
import android.content.pm.ServiceInfo;
import android.content.ComponentName;
import android.content.pm.Signature;
import android.content.IntentFilter;
import android.content.pm.IPackageDeleteObserver;
import android.content.pm.IPackageDeleteObserver2;
import android.content.pm.IPackageStatsObserver;
import com.lbe.mdremote.common.IPackageCacheInfoCallback;


interface IDAPackageManager {
    DAUser getDAUser(int vuid);
    int installPackage(int vuid, String packageName);
    int installPackage2(int vuid, String packageName, String pkgPath, int flags);
    int installPackage3(int vuid, String packageName, String pkgPath, String installer, int flags, boolean notify, boolean stopUser, boolean killGoogleApp);
    int uninstallPackage(int vuid, String packageName);
    String[] getInstalledPackageNames(int vuid);
    List<PackageInfo> getPluginInstalledPackages(int vuid, String caller, int flags);
    boolean isLockedPackage(String packageName);
    //String[] getAllInstalledPackageNames(int vuid);
    void ensurePackageOptimized(int vuid, String packageName);
    int clearApplicationUserData(int vuid, String packageName);
    int[] getUsers();
    boolean saveTemporarySignatures(String packageName);
    boolean saveTemporarySignatures2(String packageName, in Signature[] signatures);
    void forceSaveUserPackage();
    ResolveInfo resolveIntent(in int vuid, in Intent intent, in int flags);
    //getInstallPluginPackages
    List<String> getInstallPluginPackages(int vuid, String caller);
    PackageStats getPackageSizeInfo(int vuid, String packageName);
    void getPackageSizeInfo2(int vuid, String packageName, IPackageStatsObserver observer);
    int deleteApplicationCacheFiles(int vuid, String packageName);
    String[] getSortedInstalledPackageNames(int vuid, int sortType);
    boolean isCustomInstallPluginPackage(int vuid, String packageName);
    void unregisterPackageObserver(in IDAPackageObserver observer);
    void registerPackageObserver(in IDAPackageObserver observer);
    boolean isPluginPackage(int vuid, String packageName);
    int createUser();
    Uri getWrappedUri(in int vuid, in String authotity,in Uri uri);
    boolean pluginHasSharedUid(int vuid, String sharedUserName);
    DACapabilities getCapabilities(int vuid, String packageName, String processName);
    ProviderInfo resolvePluginContentProvider(int vuid, String caller, String name, int flags);
    void broadcastVirtualPackage(int vuid, String packageName, int type);
    List<PackageInfo> getPluginPackagesHoldingPermissions(in int vuid, in String caller, in String[] permissions,in int flags);
    int removeUser(int vuid);
    void addInterestedBroadcasts(String action);

    void setNotificationState(int vuid, String packageName, int state);
    int getInstalledPackages(in int vuid, in String caller, in int version, out List<DAPackage> packageList);
    boolean isPackageStopped(int vuid, String packageName);
    void installWhiteListApp(boolean sendBroadcast);
    boolean isProtectedBroadcast(String action);
    ResolveInfo resolveService(in int vuid, in Intent intent,in int flags);
    List<PermissionInfo> queryPluginPermissionsByGroup(int vuid, String caller, String group);
    void registerUserObserver(in IDAUserObserver observer);
    String getShareUserId(String packageName);
    List<ResolveInfo> queryIntentActivities(in int vuid, in Intent intent,in int flags);
    DAPackage getPackage(int vuid, String packageName);
    String[] getAllInstalledPackageNames(int vuid);
    int checkPackagePermissionInManifest(int vuid, String permission, String packageName);
    PermissionGroupInfo getPluginPermissionGroupInfo(int vuid, String caller, String group);
    boolean setPackageStopState(int vuid, String packageName, boolean state);

    List getPackageUids(String packageName);
    List<ResolveInfo> queryPluginIntentServices(in int vuid, in String caller,in Intent intent,in String resolvedType,in int flags);
    List<String> getAllPackages();
    void unregisterUserObserver(in IDAUserObserver observer);
    Map getUserPackages(int vuid);
    ApplicationInfo getPluginApplicationInfo(int vuid, String caller, String packageName, int flags);
    List<ResolveInfo> queryPluginIntentProviders(in int vuid, in String caller, in Intent intent, in String resolvedType, in int flags);
    ActivityInfo getPluginActivityInfo(in int vuid, in String caller, in ComponentName componentName, in int flags);
    void setGMSSetupCompleted(int vuid);
    List<PermissionGroupInfo> getAllPluginPermissionGroups(int vuid, String caller);
    int checkPackagePermission(String permission, String packageName);
    void setComponentEnabledSetting(in int vuid, in ComponentName componentName, in int newState, in int flags);
    boolean hasSameShareUid(String firstPackage, String secondPackage);
    List<ResolveInfo> queryIntentServices(in int vuid,in Intent intent, in int flags);
    void broadcastSystemPackage(String packageName, int type);
    IntentFilter checkForProtectedActions(in int vuid,in IntentFilter filter);
    ProviderInfo getPluginProviderInfo(in int vuid, in String caller,in ComponentName componentName, in int flags);
    String getPackageInstallerName(int vuid, String packageName);
    ActivityInfo getPluginReceiverInfo( int vuid,  String caller, in ComponentName componentName,  int flags);
    boolean gmsSetupCompleted(int vuid);
    void deletePackage(int vuid, String packageName, in IPackageDeleteObserver observer, in IPackageDeleteObserver2 observer2);
    ApplicationInfo getApplicationInfoFromSystem(String packageName);
    int checkPermission(int vuid, String permission, String packageName, String hostPkg);
    PackageInfo getPluginPackageInfo(int vuid, String caller, String packageName, int flags);
    ServiceInfo getPluginServiceInfo(int vuid, String caller, in ComponentName componentName, int flags);
    List<ApplicationInfo> getPluginInstalledApplications(int vuid, String caller, int flags);
    List<ProviderInfo> queryPluginContentProviders(int vuid, String caller, String processName, int flags);
    List<ResolveInfo> queryPluginIntentActivities(int vuid, String caller, in Intent intent, String resolvedType, int flags);
    List<ResolveInfo> queryPluginIntentReceivers(int vuid, String caller, in Intent intent, String resolvedType, int flags);
    void registerPackageCacheInfoCallback(in IPackageCacheInfoCallback callback);
    String[] getInstalledPackageNamesWithSortType(int vuid, int sortType);
    boolean isOnlyNative64Bit(in ApplicationInfo app);
    void updateInstallTime(in int vuid, in String packageName, in long installTime);

    long get32BitMigrationDataSize(in int uid, in String packageName);
    long getSDFreeSize();
    int migrateDataStatus(in int vuid, in String packageName);
    void migrateDataFrom32BitTo64Bit(in int vuid, in String packageName, in ResultReceiver resultReceiver);
    void cancelMigrateData(in int vuid, in String packageName);
}
